// import the required GraphQL Types
const {
    GraphQLObjectType,
    GraphQLInt,
    GraphQLString,
    GraphQLList,
    GraphQLID,
    GraphQLInputObjectType
  } = require('graphql');

  var GraphQLDate = require('graphql-date')    

const  db  = require('../../models');
const bcrypt = require('bcrypt')
const User = db.users;
const UserType = require('./../types/userType')  

const  createJwtToken  = require("../../util/auth")

exports.createUserMutation = {
    type : UserType,
    description: 'Create a new user',
    args:{
        username: {
            type: GraphQLString
        },
        email: {
          type: GraphQLString
        },
        password: {
            type: GraphQLString
        }
    },
    async resolve (parent, args ) {
    const hashedPassword = await bcrypt.hash(args.password, 10)
    args.password= hashedPassword    
    const user = new User(args)   

     await user.save()
    
        const token = createJwtToken(user)
        
        return token
    } 
}; 

exports.login = {
    type: GraphQLString,
    description: "Login user",
    args: {
      email: { type: GraphQLString },
      password: { type: GraphQLString },
    },
    async resolve(parent, args) {
      const user = await User.findOne({ email: args.email }).select("+password")
      console.log(user)
      if (!user || args.password !== user.password) {
        throw new Error("Invalid credentials")
      }
  
      const token = createJwtToken(user)
      return token
    },
  }